#define PERL_constant_NOTFOUND	1
#define PERL_constant_NOTDEF	2
#define PERL_constant_ISIV	3
#define PERL_constant_ISNO	4
#define PERL_constant_ISNV	5
#define PERL_constant_ISPV	6
#define PERL_constant_ISPVN	7
#define PERL_constant_ISSV	8
#define PERL_constant_ISUNDEF	9
#define PERL_constant_ISUV	10
#define PERL_constant_ISYES	11

#ifndef NVTYPE
typedef double NV; /* 5.6 and later define NVTYPE, and typedef NV to it.  */
#endif
#ifndef aTHX_
#define aTHX_ /* 5.6 or later define this for threading support.  */
#endif
#ifndef pTHX_
#define pTHX_ /* 5.6 or later define this for threading support.  */
#endif

static int
constant_13 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_DT_BOS LIBUSB_DT_HID LIBUSB_DT_HUB */
  /* Offset 11 gives the best switch position.  */
  switch (name[11]) {
  case 'I':
    if (memEQ(name, "LIBUSB_DT_HID", 13)) {
    /*                          ^        */
      *iv_return = LIBUSB_DT_HID;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_DT_BOS", 13)) {
    /*                          ^        */
      *iv_return = LIBUSB_DT_BOS;
      return PERL_constant_ISIV;
    }
    break;
  case 'U':
    if (memEQ(name, "LIBUSB_DT_HUB", 13)) {
    /*                          ^        */
      *iv_return = LIBUSB_DT_HUB;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_16 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_HID LIBUSB_CLASS_HUB LIBUSB_CLASS_PTP LIBUSB_DT_CONFIG
     LIBUSB_DT_DEVICE LIBUSB_DT_REPORT LIBUSB_DT_STRING LIBUSB_SPEED_LOW */
  /* Offset 14 gives the best switch position.  */
  switch (name[14]) {
  case 'C':
    if (memEQ(name, "LIBUSB_DT_DEVICE", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_DT_DEVICE;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSB_CLASS_HID", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_CLASS_HID;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_DT_CONFIG", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_DT_CONFIG;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_DT_STRING", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_DT_STRING;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_SPEED_LOW", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_SPEED_LOW;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_DT_REPORT", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_DT_REPORT;
      return PERL_constant_ISIV;
    }
    break;
  case 'T':
    if (memEQ(name, "LIBUSB_CLASS_PTP", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_CLASS_PTP;
      return PERL_constant_ISIV;
    }
    break;
  case 'U':
    if (memEQ(name, "LIBUSB_CLASS_HUB", 16)) {
    /*                             ^        */
      *iv_return = LIBUSB_CLASS_HUB;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_17 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_COMM LIBUSB_CLASS_DATA LIBUSB_ERROR_BUSY LIBUSB_ERROR_PIPE
     LIBUSB_SPEED_FULL LIBUSB_SPEED_HIGH */
  /* Offset 15 gives the best switch position.  */
  switch (name[15]) {
  case 'G':
    if (memEQ(name, "LIBUSB_SPEED_HIGH", 17)) {
    /*                              ^        */
      *iv_return = LIBUSB_SPEED_HIGH;
      return PERL_constant_ISIV;
    }
    break;
  case 'L':
    if (memEQ(name, "LIBUSB_SPEED_FULL", 17)) {
    /*                              ^        */
      *iv_return = LIBUSB_SPEED_FULL;
      return PERL_constant_ISIV;
    }
    break;
  case 'M':
    if (memEQ(name, "LIBUSB_CLASS_COMM", 17)) {
    /*                              ^        */
      *iv_return = LIBUSB_CLASS_COMM;
      return PERL_constant_ISIV;
    }
    break;
  case 'P':
    if (memEQ(name, "LIBUSB_ERROR_PIPE", 17)) {
    /*                              ^        */
      *iv_return = LIBUSB_ERROR_PIPE;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_ERROR_BUSY", 17)) {
    /*                              ^        */
      *iv_return = LIBUSB_ERROR_BUSY;
      return PERL_constant_ISIV;
    }
    break;
  case 'T':
    if (memEQ(name, "LIBUSB_CLASS_DATA", 17)) {
    /*                              ^        */
      *iv_return = LIBUSB_CLASS_DATA;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_18 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_API_VERSION LIBUSB_CLASS_AUDIO LIBUSB_CLASS_IMAGE
     LIBUSB_CLASS_VIDEO LIBUSB_DT_BOS_SIZE LIBUSB_DT_ENDPOINT
     LIBUSB_DT_PHYSICAL LIBUSB_ENDPOINT_IN LIBUSB_ERROR_COUNT
     LIBUSB_ERROR_OTHER LIBUSB_SPEED_SUPER */
  /* Offset 13 gives the best switch position.  */
  switch (name[13]) {
  case 'A':
    if (memEQ(name, "LIBUSB_CLASS_AUDIO", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_CLASS_AUDIO;
      return PERL_constant_ISIV;
    }
    break;
  case 'C':
    if (memEQ(name, "LIBUSB_ERROR_COUNT", 18)) {
    /*                            ^           */
#ifdef LIBUSB_ERROR_COUNT
      *iv_return = LIBUSB_ERROR_COUNT;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSB_CLASS_IMAGE", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_CLASS_IMAGE;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_ENDPOINT_IN", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_ENDPOINT_IN;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_ERROR_OTHER", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_ERROR_OTHER;
      return PERL_constant_ISIV;
    }
    break;
  case 'P':
    if (memEQ(name, "LIBUSB_DT_ENDPOINT", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_DT_ENDPOINT;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_API_VERSION", 18)) {
    /*                            ^           */
#ifdef LIBUSB_API_VERSION
      *iv_return = LIBUSB_API_VERSION;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_DT_PHYSICAL", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_DT_PHYSICAL;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_SPEED_SUPER", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_SPEED_SUPER;
      return PERL_constant_ISIV;
    }
    break;
  case 'V':
    if (memEQ(name, "LIBUSB_CLASS_VIDEO", 18)) {
    /*                            ^           */
      *iv_return = LIBUSB_CLASS_VIDEO;
      return PERL_constant_ISIV;
    }
    break;
  case '_':
    if (memEQ(name, "LIBUSB_DT_BOS_SIZE", 18)) {
    /*                            ^           */
#ifdef LIBUSB_DT_BOS_SIZE
      *iv_return = LIBUSB_DT_BOS_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_19 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSBX_API_VERSION LIBUSB_DT_INTERFACE LIBUSB_ENDPOINT_OUT
     LIBUSB_ERROR_ACCESS LIBUSB_ERROR_NO_MEM */
  /* Offset 16 gives the best switch position.  */
  switch (name[16]) {
  case 'A':
    if (memEQ(name, "LIBUSB_DT_INTERFACE", 19)) {
    /*                               ^         */
      *iv_return = LIBUSB_DT_INTERFACE;
      return PERL_constant_ISIV;
    }
    break;
  case 'E':
    if (memEQ(name, "LIBUSB_ERROR_ACCESS", 19)) {
    /*                               ^         */
      *iv_return = LIBUSB_ERROR_ACCESS;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSBX_API_VERSION", 19)) {
    /*                               ^         */
#ifdef LIBUSBX_API_VERSION
      *iv_return = LIBUSBX_API_VERSION;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'M':
    if (memEQ(name, "LIBUSB_ERROR_NO_MEM", 19)) {
    /*                               ^         */
      *iv_return = LIBUSB_ERROR_NO_MEM;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_ENDPOINT_OUT", 19)) {
    /*                               ^         */
      *iv_return = LIBUSB_ENDPOINT_OUT;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_20 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_PRINTER LIBUSB_ERROR_TIMEOUT LIBUSB_SPEED_UNKNOWN */
  /* Offset 15 gives the best switch position.  */
  switch (name[15]) {
  case 'I':
    if (memEQ(name, "LIBUSB_CLASS_PRINTER", 20)) {
    /*                              ^           */
      *iv_return = LIBUSB_CLASS_PRINTER;
      return PERL_constant_ISIV;
    }
    break;
  case 'K':
    if (memEQ(name, "LIBUSB_SPEED_UNKNOWN", 20)) {
    /*                              ^           */
      *iv_return = LIBUSB_SPEED_UNKNOWN;
      return PERL_constant_ISIV;
    }
    break;
  case 'M':
    if (memEQ(name, "LIBUSB_ERROR_TIMEOUT", 20)) {
    /*                              ^           */
      *iv_return = LIBUSB_ERROR_TIMEOUT;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_21 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_BM_LPM_SUPPORT LIBUSB_BM_LTM_SUPPORT LIBUSB_CLASS_PHYSICAL
     LIBUSB_CLASS_WIRELESS LIBUSB_DT_CONFIG_SIZE LIBUSB_DT_DEVICE_SIZE
     LIBUSB_ERROR_OVERFLOW LIBUSB_LOG_LEVEL_INFO LIBUSB_LOG_LEVEL_NONE
     LIBUSB_TRANSFER_ERROR LIBUSB_TRANSFER_STALL */
  /* Offset 17 gives the best switch position.  */
  switch (name[17]) {
  case 'F':
    if (memEQ(name, "LIBUSB_ERROR_OVERFLOW", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_ERROR_OVERFLOW;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSB_CLASS_PHYSICAL", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_CLASS_PHYSICAL;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_LOG_LEVEL_INFO", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_LOG_LEVEL_INFO;
      return PERL_constant_ISIV;
    }
    break;
  case 'L':
    if (memEQ(name, "LIBUSB_CLASS_WIRELESS", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_CLASS_WIRELESS;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_LOG_LEVEL_NONE", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_LOG_LEVEL_NONE;
      return PERL_constant_ISIV;
    }
    break;
  case 'P':
    if (memEQ(name, "LIBUSB_BM_LPM_SUPPORT", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_BM_LPM_SUPPORT;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_BM_LTM_SUPPORT", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_BM_LTM_SUPPORT;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_TRANSFER_ERROR", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_TRANSFER_ERROR;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_DT_CONFIG_SIZE", 21)) {
    /*                                ^          */
#ifdef LIBUSB_DT_CONFIG_SIZE
      *iv_return = LIBUSB_DT_CONFIG_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "LIBUSB_DT_DEVICE_SIZE", 21)) {
    /*                                ^          */
#ifdef LIBUSB_DT_DEVICE_SIZE
      *iv_return = LIBUSB_DT_DEVICE_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'T':
    if (memEQ(name, "LIBUSB_TRANSFER_STALL", 21)) {
    /*                                ^          */
      *iv_return = LIBUSB_TRANSFER_STALL;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_22 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_BT_CONTAINER_ID LIBUSB_CAP_HAS_HOTPLUG LIBUSB_DT_BOS_MAX_SIZE
     LIBUSB_ERROR_NOT_FOUND LIBUSB_ERROR_NO_DEVICE LIBUSB_LOG_LEVEL_DEBUG
     LIBUSB_LOG_LEVEL_ERROR LIBUSB_RECIPIENT_OTHER LIBUSB_REQUEST_SET_SEL
     LIBUSB_SET_ISOCH_DELAY */
  /* Offset 20 gives the best switch position.  */
  switch (name[20]) {
  case 'A':
    if (memEQ(name, "LIBUSB_SET_ISOCH_DELAY", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_SET_ISOCH_DELAY;
      return PERL_constant_ISIV;
    }
    break;
  case 'C':
    if (memEQ(name, "LIBUSB_ERROR_NO_DEVICE", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_ERROR_NO_DEVICE;
      return PERL_constant_ISIV;
    }
    break;
  case 'E':
    if (memEQ(name, "LIBUSB_RECIPIENT_OTHER", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_RECIPIENT_OTHER;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_REQUEST_SET_SEL", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_REQUEST_SET_SEL;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSB_BT_CONTAINER_ID", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_BT_CONTAINER_ID;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_ERROR_NOT_FOUND", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_ERROR_NOT_FOUND;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_LOG_LEVEL_ERROR", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_LOG_LEVEL_ERROR;
      return PERL_constant_ISIV;
    }
    break;
  case 'U':
    if (memEQ(name, "LIBUSB_CAP_HAS_HOTPLUG", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_CAP_HAS_HOTPLUG;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_LOG_LEVEL_DEBUG", 22)) {
    /*                                   ^        */
      *iv_return = LIBUSB_LOG_LEVEL_DEBUG;
      return PERL_constant_ISIV;
    }
    break;
  case 'Z':
    if (memEQ(name, "LIBUSB_DT_BOS_MAX_SIZE", 22)) {
    /*                                   ^        */
#ifdef LIBUSB_DT_BOS_MAX_SIZE
      *iv_return = LIBUSB_DT_BOS_MAX_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_23 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_SMART_CARD LIBUSB_DT_ENDPOINT_SIZE LIBUSB_RECIPIENT_DEVICE */
  /* Offset 14 gives the best switch position.  */
  switch (name[14]) {
  case 'M':
    if (memEQ(name, "LIBUSB_CLASS_SMART_CARD", 23)) {
    /*                             ^               */
      *iv_return = LIBUSB_CLASS_SMART_CARD;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_RECIPIENT_DEVICE", 23)) {
    /*                             ^               */
      *iv_return = LIBUSB_RECIPIENT_DEVICE;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_DT_ENDPOINT_SIZE", 23)) {
    /*                             ^               */
#ifdef LIBUSB_DT_ENDPOINT_SIZE
      *iv_return = LIBUSB_DT_ENDPOINT_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_24 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_APPLICATION LIBUSB_CLASS_VENDOR_SPEC LIBUSB_DT_INTERFACE_SIZE
     LIBUSB_DT_SUPERSPEED_HUB LIBUSB_ENDPOINT_DIR_MASK LIBUSB_ERROR_INTERRUPTED
     LIBUSB_HOTPLUG_ENUMERATE LIBUSB_HOTPLUG_MATCH_ANY LIBUSB_LOG_LEVEL_WARNING
     LIBUSB_TRANSFER_OVERFLOW */
  /* Offset 17 gives the best switch position.  */
  switch (name[17]) {
  case 'C':
    if (memEQ(name, "LIBUSB_DT_INTERFACE_SIZE", 24)) {
    /*                                ^             */
#ifdef LIBUSB_DT_INTERFACE_SIZE
      *iv_return = LIBUSB_DT_INTERFACE_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'E':
    if (memEQ(name, "LIBUSB_DT_SUPERSPEED_HUB", 24)) {
    /*                                ^             */
      *iv_return = LIBUSB_DT_SUPERSPEED_HUB;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSB_CLASS_APPLICATION", 24)) {
    /*                                ^             */
      *iv_return = LIBUSB_CLASS_APPLICATION;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_ENDPOINT_DIR_MASK", 24)) {
    /*                                ^             */
#ifdef LIBUSB_ENDPOINT_DIR_MASK
      *iv_return = LIBUSB_ENDPOINT_DIR_MASK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_CLASS_VENDOR_SPEC", 24)) {
    /*                                ^             */
      *iv_return = LIBUSB_CLASS_VENDOR_SPEC;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_ERROR_INTERRUPTED", 24)) {
    /*                                ^             */
      *iv_return = LIBUSB_ERROR_INTERRUPTED;
      return PERL_constant_ISIV;
    }
    break;
  case 'T':
    if (memEQ(name, "LIBUSB_HOTPLUG_MATCH_ANY", 24)) {
    /*                                ^             */
#ifdef LIBUSB_HOTPLUG_MATCH_ANY
      *iv_return = LIBUSB_HOTPLUG_MATCH_ANY;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'U':
    if (memEQ(name, "LIBUSB_HOTPLUG_ENUMERATE", 24)) {
    /*                                ^             */
      *iv_return = LIBUSB_HOTPLUG_ENUMERATE;
      return PERL_constant_ISIV;
    }
    break;
  case 'V':
    if (memEQ(name, "LIBUSB_TRANSFER_OVERFLOW", 24)) {
    /*                                ^             */
      *iv_return = LIBUSB_TRANSFER_OVERFLOW;
      return PERL_constant_ISIV;
    }
    break;
  case 'W':
    if (memEQ(name, "LIBUSB_LOG_LEVEL_WARNING", 24)) {
    /*                                ^             */
      *iv_return = LIBUSB_LOG_LEVEL_WARNING;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_25 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CAP_HAS_CAPABILITY LIBUSB_CAP_HAS_HID_ACCESS
     LIBUSB_CLASS_MASS_STORAGE LIBUSB_CONTROL_SETUP_SIZE
     LIBUSB_DT_HUB_NONVAR_SIZE LIBUSB_ISO_SYNC_TYPE_MASK
     LIBUSB_ISO_SYNC_TYPE_NONE LIBUSB_ISO_SYNC_TYPE_SYNC
     LIBUSB_RECIPIENT_ENDPOINT LIBUSB_REQUEST_GET_STATUS
     LIBUSB_REQUEST_TYPE_CLASS LIBUSB_TRANSFER_CANCELLED
     LIBUSB_TRANSFER_COMPLETED LIBUSB_TRANSFER_NO_DEVICE
     LIBUSB_TRANSFER_TIMED_OUT LIBUSB_TRANSFER_TYPE_BULK
     LIBUSB_TRANSFER_TYPE_MASK */
  /* Offset 21 gives the best switch position.  */
  switch (name[21]) {
  case 'A':
    if (memEQ(name, "LIBUSB_REQUEST_GET_STATUS", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_REQUEST_GET_STATUS;
      return PERL_constant_ISIV;
    }
    break;
  case 'B':
    if (memEQ(name, "LIBUSB_TRANSFER_TYPE_BULK", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_TRANSFER_TYPE_BULK;
      return PERL_constant_ISIV;
    }
    break;
  case 'C':
    if (memEQ(name, "LIBUSB_CAP_HAS_HID_ACCESS", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_CAP_HAS_HID_ACCESS;
      return PERL_constant_ISIV;
    }
    break;
  case 'E':
    if (memEQ(name, "LIBUSB_TRANSFER_COMPLETED", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_TRANSFER_COMPLETED;
      return PERL_constant_ISIV;
    }
    break;
  case 'L':
    if (memEQ(name, "LIBUSB_CAP_HAS_CAPABILITY", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_CAP_HAS_CAPABILITY;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_REQUEST_TYPE_CLASS", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_REQUEST_TYPE_CLASS;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_TRANSFER_CANCELLED", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_TRANSFER_CANCELLED;
      return PERL_constant_ISIV;
    }
    break;
  case 'M':
    if (memEQ(name, "LIBUSB_ISO_SYNC_TYPE_MASK", 25)) {
    /*                                    ^          */
#ifdef LIBUSB_ISO_SYNC_TYPE_MASK
      *iv_return = LIBUSB_ISO_SYNC_TYPE_MASK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "LIBUSB_TRANSFER_TYPE_MASK", 25)) {
    /*                                    ^          */
#ifdef LIBUSB_TRANSFER_TYPE_MASK
      *iv_return = LIBUSB_TRANSFER_TYPE_MASK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_ISO_SYNC_TYPE_NONE", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_ISO_SYNC_TYPE_NONE;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_RECIPIENT_ENDPOINT", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_RECIPIENT_ENDPOINT;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_CLASS_MASS_STORAGE", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_CLASS_MASS_STORAGE;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_CONTROL_SETUP_SIZE", 25)) {
    /*                                    ^          */
#ifdef LIBUSB_CONTROL_SETUP_SIZE
      *iv_return = LIBUSB_CONTROL_SETUP_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "LIBUSB_DT_HUB_NONVAR_SIZE", 25)) {
    /*                                    ^          */
#ifdef LIBUSB_DT_HUB_NONVAR_SIZE
      *iv_return = LIBUSB_DT_HUB_NONVAR_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "LIBUSB_ISO_SYNC_TYPE_SYNC", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_ISO_SYNC_TYPE_SYNC;
      return PERL_constant_ISIV;
    }
    break;
  case 'V':
    if (memEQ(name, "LIBUSB_TRANSFER_NO_DEVICE", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_TRANSFER_NO_DEVICE;
      return PERL_constant_ISIV;
    }
    break;
  case '_':
    if (memEQ(name, "LIBUSB_TRANSFER_TIMED_OUT", 25)) {
    /*                                    ^          */
      *iv_return = LIBUSB_TRANSFER_TIMED_OUT;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_26 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_PER_INTERFACE LIBUSB_ERROR_INVALID_PARAM
     LIBUSB_ERROR_NOT_SUPPORTED LIBUSB_ISO_SYNC_TYPE_ASYNC
     LIBUSB_ISO_USAGE_TYPE_DATA LIBUSB_ISO_USAGE_TYPE_MASK
     LIBUSB_LOW_SPEED_OPERATION LIBUSB_RECIPIENT_INTERFACE
     LIBUSB_REQUEST_SET_ADDRESS LIBUSB_REQUEST_SET_FEATURE
     LIBUSB_REQUEST_SYNCH_FRAME LIBUSB_REQUEST_TYPE_VENDOR */
  /* Offset 24 gives the best switch position.  */
  switch (name[24]) {
  case 'A':
    if (memEQ(name, "LIBUSB_ERROR_INVALID_PARAM", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_ERROR_INVALID_PARAM;
      return PERL_constant_ISIV;
    }
    break;
  case 'C':
    if (memEQ(name, "LIBUSB_CLASS_PER_INTERFACE", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_CLASS_PER_INTERFACE;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_RECIPIENT_INTERFACE", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_RECIPIENT_INTERFACE;
      return PERL_constant_ISIV;
    }
    break;
  case 'E':
    if (memEQ(name, "LIBUSB_ERROR_NOT_SUPPORTED", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_ERROR_NOT_SUPPORTED;
      return PERL_constant_ISIV;
    }
    break;
  case 'M':
    if (memEQ(name, "LIBUSB_REQUEST_SYNCH_FRAME", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_REQUEST_SYNCH_FRAME;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_ISO_SYNC_TYPE_ASYNC", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_ISO_SYNC_TYPE_ASYNC;
      return PERL_constant_ISIV;
    }
    break;
  case 'O':
    if (memEQ(name, "LIBUSB_LOW_SPEED_OPERATION", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_LOW_SPEED_OPERATION;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_REQUEST_TYPE_VENDOR", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_REQUEST_TYPE_VENDOR;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_REQUEST_SET_FEATURE", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_REQUEST_SET_FEATURE;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_ISO_USAGE_TYPE_MASK", 26)) {
    /*                                       ^        */
#ifdef LIBUSB_ISO_USAGE_TYPE_MASK
      *iv_return = LIBUSB_ISO_USAGE_TYPE_MASK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    if (memEQ(name, "LIBUSB_REQUEST_SET_ADDRESS", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_REQUEST_SET_ADDRESS;
      return PERL_constant_ISIV;
    }
    break;
  case 'T':
    if (memEQ(name, "LIBUSB_ISO_USAGE_TYPE_DATA", 26)) {
    /*                                       ^        */
      *iv_return = LIBUSB_ISO_USAGE_TYPE_DATA;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_27 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_BT_CONTAINER_ID_SIZE LIBUSB_BT_USB_2_0_EXTENSION
     LIBUSB_DT_DEVICE_CAPABILITY LIBUSB_FULL_SPEED_OPERATION
     LIBUSB_HIGH_SPEED_OPERATION LIBUSB_TRANSFER_FREE_BUFFER */
  /* Offset 10 gives the best switch position.  */
  switch (name[10]) {
  case 'C':
    if (memEQ(name, "LIBUSB_BT_CONTAINER_ID_SIZE", 27)) {
    /*                         ^                       */
#ifdef LIBUSB_BT_CONTAINER_ID_SIZE
      *iv_return = LIBUSB_BT_CONTAINER_ID_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'D':
    if (memEQ(name, "LIBUSB_DT_DEVICE_CAPABILITY", 27)) {
    /*                         ^                       */
      *iv_return = LIBUSB_DT_DEVICE_CAPABILITY;
      return PERL_constant_ISIV;
    }
    break;
  case 'H':
    if (memEQ(name, "LIBUSB_HIGH_SPEED_OPERATION", 27)) {
    /*                         ^                       */
      *iv_return = LIBUSB_HIGH_SPEED_OPERATION;
      return PERL_constant_ISIV;
    }
    break;
  case 'L':
    if (memEQ(name, "LIBUSB_FULL_SPEED_OPERATION", 27)) {
    /*                         ^                       */
      *iv_return = LIBUSB_FULL_SPEED_OPERATION;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_TRANSFER_FREE_BUFFER", 27)) {
    /*                         ^                       */
      *iv_return = LIBUSB_TRANSFER_FREE_BUFFER;
      return PERL_constant_ISIV;
    }
    break;
  case 'U':
    if (memEQ(name, "LIBUSB_BT_USB_2_0_EXTENSION", 27)) {
    /*                         ^                       */
      *iv_return = LIBUSB_BT_USB_2_0_EXTENSION;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_28 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_ENDPOINT_ADDRESS_MASK LIBUSB_REQUEST_CLEAR_FEATURE
     LIBUSB_REQUEST_GET_INTERFACE LIBUSB_REQUEST_SET_INTERFACE
     LIBUSB_REQUEST_TYPE_RESERVED LIBUSB_REQUEST_TYPE_STANDARD
     LIBUSB_SUPER_SPEED_OPERATION LIBUSB_TRANSFER_SHORT_NOT_OK
     LIBUSB_TRANSFER_TYPE_CONTROL */
  /* Offset 20 gives the best switch position.  */
  switch (name[20]) {
  case 'E':
    if (memEQ(name, "LIBUSB_ENDPOINT_ADDRESS_MASK", 28)) {
    /*                                   ^              */
#ifdef LIBUSB_ENDPOINT_ADDRESS_MASK
      *iv_return = LIBUSB_ENDPOINT_ADDRESS_MASK;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_REQUEST_GET_INTERFACE", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_REQUEST_GET_INTERFACE;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_REQUEST_SET_INTERFACE", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_REQUEST_SET_INTERFACE;
      return PERL_constant_ISIV;
    }
    break;
  case 'P':
    if (memEQ(name, "LIBUSB_SUPER_SPEED_OPERATION", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_SUPER_SPEED_OPERATION;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_REQUEST_TYPE_RESERVED", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_REQUEST_TYPE_RESERVED;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_REQUEST_TYPE_STANDARD", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_REQUEST_TYPE_STANDARD;
      return PERL_constant_ISIV;
    }
    break;
  case 'T':
    if (memEQ(name, "LIBUSB_TRANSFER_SHORT_NOT_OK", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_TRANSFER_SHORT_NOT_OK;
      return PERL_constant_ISIV;
    }
    break;
  case '_':
    if (memEQ(name, "LIBUSB_REQUEST_CLEAR_FEATURE", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_REQUEST_CLEAR_FEATURE;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_TRANSFER_TYPE_CONTROL", 28)) {
    /*                                   ^              */
      *iv_return = LIBUSB_TRANSFER_TYPE_CONTROL;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_29 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_CONTENT_SECURITY LIBUSB_DT_ENDPOINT_AUDIO_SIZE
     LIBUSB_ISO_SYNC_TYPE_ADAPTIVE LIBUSB_REQUEST_GET_DESCRIPTOR
     LIBUSB_REQUEST_SET_DESCRIPTOR LIBUSB_TRANSFER_FREE_TRANSFER */
  /* Offset 8 gives the best switch position.  */
  switch (name[8]) {
  case 'E':
    if (memEQ(name, "LIBUSB_REQUEST_GET_DESCRIPTOR", 29)) {
    /*                       ^                           */
      *iv_return = LIBUSB_REQUEST_GET_DESCRIPTOR;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_REQUEST_SET_DESCRIPTOR", 29)) {
    /*                       ^                           */
      *iv_return = LIBUSB_REQUEST_SET_DESCRIPTOR;
      return PERL_constant_ISIV;
    }
    break;
  case 'L':
    if (memEQ(name, "LIBUSB_CLASS_CONTENT_SECURITY", 29)) {
    /*                       ^                           */
      *iv_return = LIBUSB_CLASS_CONTENT_SECURITY;
      return PERL_constant_ISIV;
    }
    break;
  case 'R':
    if (memEQ(name, "LIBUSB_TRANSFER_FREE_TRANSFER", 29)) {
    /*                       ^                           */
      *iv_return = LIBUSB_TRANSFER_FREE_TRANSFER;
      return PERL_constant_ISIV;
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_ISO_SYNC_TYPE_ADAPTIVE", 29)) {
    /*                       ^                           */
      *iv_return = LIBUSB_ISO_SYNC_TYPE_ADAPTIVE;
      return PERL_constant_ISIV;
    }
    break;
  case 'T':
    if (memEQ(name, "LIBUSB_DT_ENDPOINT_AUDIO_SIZE", 29)) {
    /*                       ^                           */
#ifdef LIBUSB_DT_ENDPOINT_AUDIO_SIZE
      *iv_return = LIBUSB_DT_ENDPOINT_AUDIO_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_30 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_CLASS_DIAGNOSTIC_DEVICE LIBUSB_ISO_USAGE_TYPE_FEEDBACK
     LIBUSB_ISO_USAGE_TYPE_IMPLICIT LIBUSB_TRANSFER_TYPE_INTERRUPT */
  /* Offset 22 gives the best switch position.  */
  switch (name[22]) {
  case 'C':
    if (memEQ(name, "LIBUSB_CLASS_DIAGNOSTIC_DEVICE", 30)) {
    /*                                     ^              */
      *iv_return = LIBUSB_CLASS_DIAGNOSTIC_DEVICE;
      return PERL_constant_ISIV;
    }
    break;
  case 'F':
    if (memEQ(name, "LIBUSB_ISO_USAGE_TYPE_FEEDBACK", 30)) {
    /*                                     ^              */
      *iv_return = LIBUSB_ISO_USAGE_TYPE_FEEDBACK;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSB_ISO_USAGE_TYPE_IMPLICIT", 30)) {
    /*                                     ^              */
      *iv_return = LIBUSB_ISO_USAGE_TYPE_IMPLICIT;
      return PERL_constant_ISIV;
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_TRANSFER_TYPE_INTERRUPT", 30)) {
    /*                                     ^              */
      *iv_return = LIBUSB_TRANSFER_TYPE_INTERRUPT;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant_32 (pTHX_ const char *name, IV *iv_return) {
  /* When generated this function returned values for the list of names given
     here.  However, subsequent manual editing may have added or removed some.
     LIBUSB_BT_USB_2_0_EXTENSION_SIZE LIBUSB_CLASS_PERSONAL_HEALTHCARE
     LIBUSB_DT_DEVICE_CAPABILITY_SIZE LIBUSB_HOTPLUG_EVENT_DEVICE_LEFT
     LIBUSB_REQUEST_GET_CONFIGURATION LIBUSB_REQUEST_SET_CONFIGURATION
     LIBUSB_TRANSFER_TYPE_ISOCHRONOUS */
  /* Offset 22 gives the best switch position.  */
  switch (name[22]) {
  case 'E':
    if (memEQ(name, "LIBUSB_HOTPLUG_EVENT_DEVICE_LEFT", 32)) {
    /*                                     ^                */
      *iv_return = LIBUSB_HOTPLUG_EVENT_DEVICE_LEFT;
      return PERL_constant_ISIV;
    }
    break;
  case 'F':
    if (memEQ(name, "LIBUSB_REQUEST_GET_CONFIGURATION", 32)) {
    /*                                     ^                */
      *iv_return = LIBUSB_REQUEST_GET_CONFIGURATION;
      return PERL_constant_ISIV;
    }
    if (memEQ(name, "LIBUSB_REQUEST_SET_CONFIGURATION", 32)) {
    /*                                     ^                */
      *iv_return = LIBUSB_REQUEST_SET_CONFIGURATION;
      return PERL_constant_ISIV;
    }
    break;
  case 'H':
    if (memEQ(name, "LIBUSB_CLASS_PERSONAL_HEALTHCARE", 32)) {
    /*                                     ^                */
      *iv_return = LIBUSB_CLASS_PERSONAL_HEALTHCARE;
      return PERL_constant_ISIV;
    }
    break;
  case 'I':
    if (memEQ(name, "LIBUSB_DT_DEVICE_CAPABILITY_SIZE", 32)) {
    /*                                     ^                */
#ifdef LIBUSB_DT_DEVICE_CAPABILITY_SIZE
      *iv_return = LIBUSB_DT_DEVICE_CAPABILITY_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'N':
    if (memEQ(name, "LIBUSB_BT_USB_2_0_EXTENSION_SIZE", 32)) {
    /*                                     ^                */
#ifdef LIBUSB_BT_USB_2_0_EXTENSION_SIZE
      *iv_return = LIBUSB_BT_USB_2_0_EXTENSION_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 'S':
    if (memEQ(name, "LIBUSB_TRANSFER_TYPE_ISOCHRONOUS", 32)) {
    /*                                     ^                */
      *iv_return = LIBUSB_TRANSFER_TYPE_ISOCHRONOUS;
      return PERL_constant_ISIV;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

static int
constant (pTHX_ const char *name, STRLEN len, IV *iv_return) {
  /* Initially switch on the length of the name.  */
  /* When generated this function returned values for the list of names given
     in this section of perl code.  Rather than manually editing these functions
     to add or remove constants, which would result in this comment and section
     of code becoming inaccurate, we recommend that you edit this section of
     code, and use it to regenerate a new set of constant functions which you
     then use to replace the originals.

     Regenerate these constant functions by feeding this entire source file to
     perl -x

#!/usr/bin/perl5.38.0 -w
use ExtUtils::Constant qw (constant_types C_constant XS_constant);

my $types = {map {($_, 1)} qw(IV)};
my @names = (qw(LIBUSBX_API_VERSION LIBUSB_API_VERSION
	       LIBUSB_BT_CONTAINER_ID_SIZE
	       LIBUSB_BT_SS_USB_DEVICE_CAPABILITY_SIZE
	       LIBUSB_BT_USB_2_0_EXTENSION_SIZE LIBUSB_CONTROL_SETUP_SIZE
	       LIBUSB_DT_BOS_MAX_SIZE LIBUSB_DT_BOS_SIZE LIBUSB_DT_CONFIG_SIZE
	       LIBUSB_DT_DEVICE_CAPABILITY_SIZE LIBUSB_DT_DEVICE_SIZE
	       LIBUSB_DT_ENDPOINT_AUDIO_SIZE LIBUSB_DT_ENDPOINT_SIZE
	       LIBUSB_DT_HUB_NONVAR_SIZE LIBUSB_DT_INTERFACE_SIZE
	       LIBUSB_DT_SS_ENDPOINT_COMPANION_SIZE
	       LIBUSB_ENDPOINT_ADDRESS_MASK LIBUSB_ENDPOINT_DIR_MASK
	       LIBUSB_ERROR_COUNT LIBUSB_HOTPLUG_MATCH_ANY
	       LIBUSB_ISO_SYNC_TYPE_MASK LIBUSB_ISO_USAGE_TYPE_MASK
	       LIBUSB_TRANSFER_TYPE_MASK),
            {name=>"LIBUSB_BM_LPM_SUPPORT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_BM_LTM_SUPPORT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_BT_CONTAINER_ID", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_BT_SS_USB_DEVICE_CAPABILITY", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_BT_USB_2_0_EXTENSION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_BT_WIRELESS_USB_DEVICE_CAPABILITY", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CAP_HAS_CAPABILITY", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CAP_HAS_HID_ACCESS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CAP_HAS_HOTPLUG", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CAP_SUPPORTS_DETACH_KERNEL_DRIVER", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_APPLICATION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_AUDIO", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_COMM", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_CONTENT_SECURITY", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_DATA", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_DIAGNOSTIC_DEVICE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_HID", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_HUB", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_IMAGE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_MASS_STORAGE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_PERSONAL_HEALTHCARE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_PER_INTERFACE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_PHYSICAL", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_PRINTER", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_PTP", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_SMART_CARD", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_VENDOR_SPEC", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_VIDEO", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_CLASS_WIRELESS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_BOS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_CONFIG", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_DEVICE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_DEVICE_CAPABILITY", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_ENDPOINT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_HID", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_HUB", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_INTERFACE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_PHYSICAL", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_REPORT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_SS_ENDPOINT_COMPANION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_STRING", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_DT_SUPERSPEED_HUB", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ENDPOINT_IN", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ENDPOINT_OUT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_ACCESS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_BUSY", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_INTERRUPTED", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_INVALID_PARAM", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_IO", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_NOT_FOUND", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_NOT_SUPPORTED", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_NO_DEVICE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_NO_MEM", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_OTHER", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_OVERFLOW", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_PIPE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ERROR_TIMEOUT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_FULL_SPEED_OPERATION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_HIGH_SPEED_OPERATION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_HOTPLUG_ENUMERATE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_HOTPLUG_EVENT_DEVICE_ARRIVED", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_HOTPLUG_EVENT_DEVICE_LEFT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ISO_SYNC_TYPE_ADAPTIVE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ISO_SYNC_TYPE_ASYNC", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ISO_SYNC_TYPE_NONE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ISO_SYNC_TYPE_SYNC", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ISO_USAGE_TYPE_DATA", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ISO_USAGE_TYPE_FEEDBACK", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_ISO_USAGE_TYPE_IMPLICIT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_LOG_LEVEL_DEBUG", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_LOG_LEVEL_ERROR", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_LOG_LEVEL_INFO", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_LOG_LEVEL_NONE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_LOG_LEVEL_WARNING", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_LOW_SPEED_OPERATION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_RECIPIENT_DEVICE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_RECIPIENT_ENDPOINT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_RECIPIENT_INTERFACE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_RECIPIENT_OTHER", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_CLEAR_FEATURE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_GET_CONFIGURATION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_GET_DESCRIPTOR", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_GET_INTERFACE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_GET_STATUS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_SET_ADDRESS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_SET_CONFIGURATION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_SET_DESCRIPTOR", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_SET_FEATURE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_SET_INTERFACE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_SET_SEL", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_SYNCH_FRAME", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_TYPE_CLASS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_TYPE_RESERVED", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_TYPE_STANDARD", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_REQUEST_TYPE_VENDOR", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SET_ISOCH_DELAY", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SPEED_FULL", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SPEED_HIGH", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SPEED_LOW", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SPEED_SUPER", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SPEED_UNKNOWN", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SUCCESS", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_SUPER_SPEED_OPERATION", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_ADD_ZERO_PACKET", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_CANCELLED", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_COMPLETED", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_ERROR", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_FREE_BUFFER", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_FREE_TRANSFER", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_NO_DEVICE", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_OVERFLOW", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_SHORT_NOT_OK", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_STALL", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_TIMED_OUT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_TYPE_BULK", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_TYPE_CONTROL", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_TYPE_INTERRUPT", type=>"IV", macro=>"1"},
            {name=>"LIBUSB_TRANSFER_TYPE_ISOCHRONOUS", type=>"IV", macro=>"1"});

print constant_types(), "\n"; # macro defs
foreach (C_constant ("USB::LibUSB::XS", 'constant', 'IV', $types, undef, 3, @names) ) {
    print $_, "\n"; # C constant subs
}
print "\n#### XS Section:\n";
print XS_constant ("USB::LibUSB::XS", $types);
__END__
   */

  switch (len) {
  case 13:
    return constant_13 (aTHX_ name, iv_return);
    break;
  case 14:
    if (memEQ(name, "LIBUSB_SUCCESS", 14)) {
      *iv_return = LIBUSB_SUCCESS;
      return PERL_constant_ISIV;
    }
    break;
  case 15:
    if (memEQ(name, "LIBUSB_ERROR_IO", 15)) {
      *iv_return = LIBUSB_ERROR_IO;
      return PERL_constant_ISIV;
    }
    break;
  case 16:
    return constant_16 (aTHX_ name, iv_return);
    break;
  case 17:
    return constant_17 (aTHX_ name, iv_return);
    break;
  case 18:
    return constant_18 (aTHX_ name, iv_return);
    break;
  case 19:
    return constant_19 (aTHX_ name, iv_return);
    break;
  case 20:
    return constant_20 (aTHX_ name, iv_return);
    break;
  case 21:
    return constant_21 (aTHX_ name, iv_return);
    break;
  case 22:
    return constant_22 (aTHX_ name, iv_return);
    break;
  case 23:
    return constant_23 (aTHX_ name, iv_return);
    break;
  case 24:
    return constant_24 (aTHX_ name, iv_return);
    break;
  case 25:
    return constant_25 (aTHX_ name, iv_return);
    break;
  case 26:
    return constant_26 (aTHX_ name, iv_return);
    break;
  case 27:
    return constant_27 (aTHX_ name, iv_return);
    break;
  case 28:
    return constant_28 (aTHX_ name, iv_return);
    break;
  case 29:
    return constant_29 (aTHX_ name, iv_return);
    break;
  case 30:
    return constant_30 (aTHX_ name, iv_return);
    break;
  case 31:
    /* Names all of length 31.  */
    /* LIBUSB_DT_SS_ENDPOINT_COMPANION LIBUSB_TRANSFER_ADD_ZERO_PACKET */
    /* Offset 8 gives the best switch position.  */
    switch (name[8]) {
    case 'R':
      if (memEQ(name, "LIBUSB_TRANSFER_ADD_ZERO_PACKET", 31)) {
      /*                       ^                             */
        *iv_return = LIBUSB_TRANSFER_ADD_ZERO_PACKET;
        return PERL_constant_ISIV;
      }
      break;
    case 'T':
      if (memEQ(name, "LIBUSB_DT_SS_ENDPOINT_COMPANION", 31)) {
      /*                       ^                             */
        *iv_return = LIBUSB_DT_SS_ENDPOINT_COMPANION;
        return PERL_constant_ISIV;
      }
      break;
    }
    break;
  case 32:
    return constant_32 (aTHX_ name, iv_return);
    break;
  case 34:
    if (memEQ(name, "LIBUSB_BT_SS_USB_DEVICE_CAPABILITY", 34)) {
      *iv_return = LIBUSB_BT_SS_USB_DEVICE_CAPABILITY;
      return PERL_constant_ISIV;
    }
    break;
  case 35:
    if (memEQ(name, "LIBUSB_HOTPLUG_EVENT_DEVICE_ARRIVED", 35)) {
      *iv_return = LIBUSB_HOTPLUG_EVENT_DEVICE_ARRIVED;
      return PERL_constant_ISIV;
    }
    break;
  case 36:
    if (memEQ(name, "LIBUSB_DT_SS_ENDPOINT_COMPANION_SIZE", 36)) {
#ifdef LIBUSB_DT_SS_ENDPOINT_COMPANION_SIZE
      *iv_return = LIBUSB_DT_SS_ENDPOINT_COMPANION_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 39:
    if (memEQ(name, "LIBUSB_BT_SS_USB_DEVICE_CAPABILITY_SIZE", 39)) {
#ifdef LIBUSB_BT_SS_USB_DEVICE_CAPABILITY_SIZE
      *iv_return = LIBUSB_BT_SS_USB_DEVICE_CAPABILITY_SIZE;
      return PERL_constant_ISIV;
#else
      return PERL_constant_NOTDEF;
#endif
    }
    break;
  case 40:
    /* Names all of length 40.  */
    /* LIBUSB_BT_WIRELESS_USB_DEVICE_CAPABILITY
       LIBUSB_CAP_SUPPORTS_DETACH_KERNEL_DRIVER */
    /* Offset 7 gives the best switch position.  */
    switch (name[7]) {
    case 'B':
      if (memEQ(name, "LIBUSB_BT_WIRELESS_USB_DEVICE_CAPABILITY", 40)) {
      /*                      ^                                       */
        *iv_return = LIBUSB_BT_WIRELESS_USB_DEVICE_CAPABILITY;
        return PERL_constant_ISIV;
      }
      break;
    case 'C':
      if (memEQ(name, "LIBUSB_CAP_SUPPORTS_DETACH_KERNEL_DRIVER", 40)) {
      /*                      ^                                       */
        *iv_return = LIBUSB_CAP_SUPPORTS_DETACH_KERNEL_DRIVER;
        return PERL_constant_ISIV;
      }
      break;
    }
    break;
  }
  return PERL_constant_NOTFOUND;
}

